VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDFetcher"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3841B02F0202"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Data Fetcher"
'This class will not be involved in MTS transactions.  The transactional attribute is set to: Does not support transactions.
Option Explicit

'The GetList method returns the complete CD catalog.
'Arguments: None
'Returns: A Read-Only Recordset containing the following fields:
'- CD_DBID
'- Composer
'- Composition
'- Performer
'- Conductor
'- Price
'##ModelId=384D91F5038E
Public Function getList() As Recordset
    On Error GoTo getListErr

        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        sqlCommand.ActiveConnection = currentConnection
        sqlCommand.CommandText = "cdCatalog"
        sqlCommand.CommandType = adCmdStoredProc
        sqlCommand.CommandTimeout = 15
        
        Set getList = sqlCommand.Execute()

    Exit Function
getListErr:
    Call RaiseError(MyUnhandledError, "GetList Function")
End Function


'The GetByID method takes the database ID of a CD and returns a recordset containing data about only that CD.
'Arguments: intCD_DBID : Integer
'Returns: A static Recordset containing the following fields:
'- CD_DBID
'- Image
'- Price
'- Composer
'- Composition
'- Performer
'- Conductor
'- Description
'

'##ModelId=384D923B038F
Public Function getByID(intCD_DBID As Integer) As Recordset
    On Error GoTo getByIDErr
        
        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        sqlCommand.ActiveConnection = currentConnection
        sqlCommand.CommandText = "cdDetail"
        sqlCommand.CommandType = adCmdStoredProc
        sqlCommand.CommandTimeout = 15
        
        Dim sqlParameter As ADODB.Parameter
        Set sqlParameter = sqlCommand.CreateParameter("cdID", adInteger, adParamInput, , intCD_DBID)
        sqlCommand.Parameters.Append sqlParameter
        
        Set getByID = sqlCommand.Execute()

    Exit Function
getByIDErr:
    Call RaiseError(MyUnhandledError, "GetByID Function")
End Function


'The Search method returns a searched subset of the complete CD catalog.
'Arguments: searchString and seatchCriteria
'Returns: A Read-Only Recordset containing the following fields:
'- CD_DBID
'- Composer
'- Composition
'- Performer
'- Conductor
'- Price
'Criteria for search:
'- Composer (Criteria = 1)
'- Composition (Criteria = 2)
'- Performer (Criteria = 3)
'- Conductor (Criteria = 4)
'##ModelId=384D91F5038E
Public Function Search(strCDSearchString As String, intCDSearchCriteria As Integer) As Recordset
    On Error GoTo searchErr

        Dim currentConnection As ADODB.Connection
        Set currentConnection = CreateObject("ADODB.Connection")
        currentConnection.connectionString = connectionString
        Call currentConnection.Open
        
        Dim sqlCommand As ADODB.Command
        Set sqlCommand = CreateObject("ADODB.Command")
        sqlCommand.ActiveConnection = currentConnection
        Select Case intCDSearchCriteria
        Case 1
            sqlCommand.CommandText = "cdSearchComposer"
        Case 2
            sqlCommand.CommandText = "cdSearchComposition"
        Case 3
            sqlCommand.CommandText = "cdSearchPerformer"
        Case Else
            sqlCommand.CommandText = "cdSearchConductor"
        End Select
        sqlCommand.CommandType = adCmdStoredProc
        sqlCommand.CommandTimeout = 15
        
        Dim sqlParameter As ADODB.Parameter
        Set sqlParameter = sqlCommand.CreateParameter("cdSearchString", adVarChar, adParamInput, 20, strCDSearchString)
        sqlCommand.Parameters.Append sqlParameter
        
        Set Search = sqlCommand.Execute()

    Exit Function
searchErr:
    Call RaiseError(MyUnhandledError, "Search Function")
End Function

