VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ShipmentStatus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Sub OutputDebugString Lib "kernel32" Alias "OutputDebugStringA" (ByVal lpOutputString As String)

Public Function GetShipmentStatus(ByVal sTrackingNumber As String) As String
    Call OutputDebugString(">>GetShipmentStatus" & vbCrLf)
    On Error GoTo GetShipmentStatusErr
    
    Dim sReturnStatus As String 'the return value
    
    Debug.Assert (Len(sTrackingNumber) > 1) 'input assumption
    Debug.Assert (IsNumeric(sTrackingNumber) = True) 'input assumption
    
    Call OutputDebugString("After asserts - Len = " & Len(sTrackingNumber) & vbCrLf)

    'hard coded status' depending upon the value of the last numeric in the tracking number
    Select Case (Val(Right$(sTrackingNumber, 1)) Mod 3)
        Case 0:
            sReturnStatus = "Waiting to pickup order from shipper"
            
        Case 1:
            sReturnStatus = "Shipment in Memphis"
            
        Case 2:
            sReturnStatus = "Shipment in local warehouse, should be delivered today"
            
        Case Else
            sReturnStatus = "Invalid tracking number"
            
    End Select
    
    Debug.Assert (Len(sReturnStatus) > 0) 'output assumption
    
    Call OutputDebugString("<<ReturnVal = [" & sReturnStatus & "]" & vbCrLf)
    GetShipmentStatus = sReturnStatus
    Exit Function

GetShipmentStatusErr:
    Call OutputDebugString("Error " & Err.Number & " (0x" & Hex(Err.Number) & " - " & Err.Description & vbCrLf)
    Call RaiseError(MyUnhandledError, "GetShipmentStatus Function")
End Function

