<%
'***********************************************************************
'					ASP SOAP Listener
'				  Build 205 @ 07/10/2000
'***********************************************************************

'***********************************************************************
'						DECLARATIONS AND SETTINGS
'***********************************************************************
CONST ERROR_FILENAME		= "SOAP_ERRORLOG.txt"			'Will be created auto if no exist
CONST WEBSERVICESFOLDER_LOC	= "C:\WebServices"				'Will be created auto if no exist
CONST LOGERRORS				= TRUE							'Log all errors in WEBSERVICESFOLDER_LOC + ERROR_FILENAME
CONST LOGERRORS_USERIP		= FALSE
CONST USEPHYSICAL_SDLLOC	= FALSE							'For performance enhancement, you can set this
															'to TRUE which allows this listener code to retrieve the 
															'SDL through the FileSystem Object instead of a round trip

'***********************************************************************
'					FILE SYSTEM OBJECT CONSTANTS
'***********************************************************************
CONST ForReading = 1, ForWriting = 2, ForAppending = 8
CONST TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0

'***********************************************************************
'					RETURN FAULTCODE ERROR TYPES
'***********************************************************************
CONST SERR_VERSIONMISMATCH	= 100	'The call was using an unsupported SOAP version.
CONST SERR_MUSTUNDERSTAND	= 200	'An XML element was received that contained an element 
									'tagged with mustUnderstand="1" that was not understood 
									'by the receiver.
CONST SERR_INVALIDREQUEST	= 300	'The receiving application did not process the request 
									'because it was incorrectly formed or not supported by the application.
CONST SERR_APPLICATIONFAULT	= 400	'The receiving application faulted when processing the request. 
									'The 'detail' element contains the application-specific fault.

'***********************************************************************
'				ENUM tagVALIDTYPES, Member of ROPE
'***********************************************************************
CONST icVT_BOOL			= 11		'Boolean
CONST icVT_BSTR			= 8			'String
CONST icVT_DECIMAL		= 14		'Single
CONST icVT_EMPTY		= 0			'No type / null data
CONST icVT_I1			= 16		'Byte integer
CONST icVT_I2			= 2			'Short/int integer
CONST icVT_I4			= 3			'Long integer
CONST icVT_R4			= 4			'Single
CONST icVT_R8			= 5			'Double
CONST icVT_UI1			= 17		'Unsigned byte integer
CONST icVT_UI2			= 18		'Unsigned short/int integer
CONST icVT_UI4			= 19		'Unsigned long integer
CONST icVT_UNKNOWN		= 13		'Unknown data type

'***********************************************************************
'				OTHER ENUMUMERATED Values, Member of ROPE
'***********************************************************************

'PAYLOADTYPES
CONST icRESPONSE			= 1			'SOAP Payload type (outgoing)
CONST icREQUEST				= 0			'SOAP Payload type (incoming)
'SCHEMASOURCE
CONST icURI					= 1			'Schema location type (URI based)
CONST icSTRING				= 2			'Schema location type (string based)
'MethodType
CONST icMETHOD				= 2			'Interaction type (no return data)
CONST icFUNCTION			= 1			'Interaction type (has return data)
'MessageDirectionType
CONST icINPUT				= 0			'Input message structure
CONST icOUTPUT				= 1			'Output message structure
'PARAMETERDIRECTIONTYPES
CONST icINONLY				= 0			'Parameter direction
CONST icOUTONLY				= 1			'Parameter direction
CONST icBOTH				= 2			'Parameter direction
'SERVICEDESCRIPTORTYPE
CONST icMETHODINFO			= 1
CONST icENDPOINTINFO		= 0
CONST icSOAPHEADERINFO		= 2
'PARAMETERLISTTYPES
CONST icPARAMETERORDER		= 2
CONST icREQUESTPARAMETERS	= 0
CONST icRESPONSEPARAMETERS	= 1


'***********************************************************************

Dim objSOAPPackager			'As Rope.SOAPPackager
Dim objSDMethod
Dim objROPECollection
Dim objSDParameter

Dim aParameters()			'Array of parameters from the SDL
Dim aCallParams()			'Array of parameters that will be passed to the method call
Dim aOutParams()			'Array of OUT or IN/OUT parameters if there are any

Dim xmlPost					'Incoming XML post
Dim strServiceName			'The interface being called by this post. This is represented
							'by the first child of the SOAP:Body element.  There can only
							'be one by SOAP definition
Dim strSDLLocation			'This will either be posted within HTTP headers as "SDLLocation" or
							'we will use the constant SOAP_SDLURI which would be the default
							'if no sdl location was posted in the headers
Dim strParameterString		'Parameter string intended to be passed through the method call
Dim strRequestStruct		'Request struct for the param calls
Dim strResponseStruct		'Response struct 

Dim xmlDOM					'The XML DOM object that the posted xml is loaded into to be parsed
Dim strEval					'String to apply eval function to (executes the method)
Dim strXMLRequest			'The input to this page (XML string)
Dim strXMLResponse			'The output of this page (XML string)
Dim iCounterX				'Counter
Dim blnIsFunction			'True if this is a function call vs. a simple method
Dim blnIsOutput				'True if there is any output whatsoever

'Dim strMethodInvocHeader	'See 6.3 at http://msdn.microsoft.com/xml/general/soapspec-v1.asp
%>
	

<%

'____________________________________________________________________________________________________________________________________________________________

Sub LogError(ErrorString, ErrorNumber)
	If LOGERRORS Then
		Dim objFSO
		Dim objFolder
		Dim objFileCreate
	
		Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
		If Not objFSO.FolderExists(WEBSERVICESFOLDER_LOC) Then
			Set objFolder = objFSO.CreateFolder(WEBSERVICESFOLDER_LOC)
			Set objFolder = NOTHING
		End If
		Set objFileCreate = objFSO.OpenTextFile(WEBSERVICESFOLDER_LOC & "\" & ERROR_FILENAME, ForAppending, True, TristateUseDefault)
		'Write out the error with details
		objFileCreate.Write Now & vbTab & ErrorString & vbTab & ErrorNumber 
		
		If LOGERRORS_USERIP Then
			objFileCreate.Writeline vbTab & Request.ServerVariables("REMOTE_ADDR") 
		Else
			objFileCreate.Writeline
		End If
	
		objFileCreate.close	
		Set objFileCreate = NOTHING
		Set objFSO = NOTHING
	End If
	'Need to package up the second half of the error correctly here.
	ReturnFaultPackage ErrorNumber, ErrorString, ErrorNumber, ErrorString
End Sub

'____________________________________________________________________________________________________________________________________________________________

Sub LogMessage(Msg)
	Dim objFSO
	Dim objFolder
	Dim objFileCreate

	
	Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
	If Not objFSO.FolderExists(WEBSERVICESFOLDER_LOC) Then
		Set objFolder = objFSO.CreateFolder(WEBSERVICESFOLDER_LOC)
		Set objFolder = NOTHING
	End If
	Set objFileCreate = objFSO.OpenTextFile(WEBSERVICESFOLDER_LOC & "\" & ERROR_FILENAME, ForAppending, True, TristateUseDefault)
	'Write out the error with details
	objFileCreate.Write Now & vbTab & Msg 
	If LOGERRORS_USERIP Then
		objFileCreate.Writeline vbTab & Request.ServerVariables("REMOTE_ADDR") 
	Else
		objFileCreate.Writeline
	End IF
	
	objFileCreate.close	
	Set objFileCreate = NOTHING
	Set objFSO = NOTHING
End Sub

'____________________________________________________________________________________________________________________________________________________________


Sub ReturnFaultPackage(iFaultCode, strFaultDetail, iFaultActor, strFaultString)
	'Create the object if it doesn't exist
	If Not IsObject(objSOAPPackager) Then
		Set objSOAPPackager	= Server.CreateObject("Rope.SOAPPackager")
	End If

	objSOAPPackager.FaultCode = iFaultCode
	objSOAPPackager.FaultDetail = strFaultDetail
	objSOAPPackager.FaultActor = iFaultActor
	objSOAPPackager.FaultString = strFaultString
	Response.Write objSOAPPackager.FaultPayload

	Set objSOAPPackager = NOTHING
	Set objSDMethod	= NOTHING
	Set objSDParameter	= NOTHING
	Response.End 
End Sub
'____________________________________________________________________________________________________________________________________________________________
Function GetThisFolderURLName()
	'Returns the URL of this folder
	Dim strFolder
	Dim iCounter
	
	strFolder = Request.ServerVariables("PATH_INFO")
	For iCounter = Len(strFolder) to 1 Step -1
		If mid(strFolder, iCounter, 1) = "/" Then Exit For
	Next
	
	strFolder = left(strFolder, iCounter)
	strFolder = "http://" &  Request.ServerVariables("REMOTE_HOST") & strFolder
	GetThisFolderURLName = strFolder
End Function
'____________________________________________________________________________________________________________________________________________________________

Function GetSDLAsText()
	'Optionally, this function will get called iff USEPHYSICAL_SDLLOC = TRUE. This
	'will increase performance slightly by allowing this listener to retrieve the
	'schema from the physical location rather than use http
	Dim strSchemaLocPhys
	Dim strSchemaLocURI
	Dim strSchema
	Dim objFSOz
	Dim objTextStream
	Dim iServerSepLoc
	Dim iCounter
	Dim iTemp
	Dim iTemp2
	
	iServerSepLoc = 1
	iCounter = 1
	
	'Find the appropriate location to strip off the
	'server so we can map a path to it
	Do Until iCounter = 4
		iTemp = instr(iServerSepLoc, strSDLLocation, "/")
		iCounter = iCounter + 1
		iServerSepLoc = iTemp + 1
	Loop
	
	strSchemaLocURI = mid(strSDLLocation,iServerSepLoc - 1, len(strSDLLocation))
	strSchemaLocPhys = server.MapPath(strSchemaLocURI)
	
	Set objFSOz = Server.CreateObject("Scripting.FileSystemObject")
	Set objTextStream = objFSOz.OpenTextFile(strSchemaLocPhys,ForReading,False,TristateUseDefault)
	strSchema = objTextStream.ReadAll()
	objTextStream.Close
	
	Set objTextStream = NOTHING
	Set objFSOz = NOTHING
	
	GetSDLAsText = strSchema
End Function
'____________________________________________________________________________________________________________________________________________________________

Sub GetService()
	'Grabs the interfaces from the currently loaded payload 
	'and populates the strServiceName string variable

	ON ERROR RESUME NEXT

	strServiceName = objSOAPPackager.GetMethodName(icREQUEST)
	
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0 
	End If

End Sub
'____________________________________________________________________________________________________________________________________________________________

Sub BuildOutputParamArray()
	'Pass in array of Out params
	Dim iPCount
	Dim otmpMethod		'SDMethodInfo
	Dim otmpParam		'SDParameterInfo
	Dim tmpCounter		'Int counter
	Dim iStartPoint		'Index for starting point of out parameters.  If this
						'is a function, we start at 1.  Else we start at 0
	
	blnIsOutput = FALSE
	iStartPoint = 0
	
	If blnIsFunction Then iStartPoint = 1
	
	Set otmpMethod = Server.CreateObject("ROPE.SDMethodInfo")
	Set otmpParam = Server.CreateObject("ROPE.SDParameterInfo")

	Set otmpMethod = objROPECollection(trim(cstr(strServiceName)))
	iPCount = otmpMethod.FillParameterArraySize(icRESPONSEPARAMETERS)
	Redim aOutParams(iPCount)
	otmpMethod.FillParameterArray icRESPONSEPARAMETERS, aOutParams
	
	For tmpCounter = 0 to (UBOUND(aOutParams) - 1)
		Set otmpParam = aOutParams(tmpCounter)
		blnIsOutput = TRUE
		Exit For
	Next

	'By definition
	If blnIsFunction Then blnIsOutput = TRUE

	Set otmpMethod = NOTHING
	Set otmpParam = NOTHING

End Sub
'____________________________________________________________________________________________________________________________________________________________

Function ConstructParameterList()
	'Grabs the parameter(s) from the currently loaded payload 
	'and returns a comma delimited string in the proper call order
	 
	Dim strParamList
	Dim iCounter
	Dim iParamCount
	Dim iInputParamCount
	Dim vParamValue
	Dim iIndex
	ON ERROR RESUME NEXT
	 
	strParamList = ""
	
	iIndex = 0		'This is the index passed to the FormatDataType function to order the 
					'array of the aCallParams() array

	iInputParamCount = objSDMethod.FillParameterArraySize(icREQUESTPARAMETERS)
	iParamCount = objSDMethod.FillParameterArraySize(icPARAMETERORDER)

	Redim aParameters(iParamCount)
	objSDMethod.FillParameterArray icPARAMETERORDER, aParameters
	For iCounter = 0 to (UBound(aParameters) - 1)
		Set objSDParameter = aParameters(iCounter)
	Next

	If iParamCount = 0 Then
		ConstructParameterList = ""
		Exit Function
	End If

	If (iInputParamCount = 0) AND blnIsFunction Then
		ConstructParameterList = ""
		Exit Function
	End If
	
	Redim aCallParams(iParamCount)
	Redim aParameters(iParamCount)
	objSDMethod.FillParameterArray icPARAMETERORDER, aParameters
	
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0 
	End If		
	
	For iCounter = 0 to (UBound(aParameters) - 1)
		Set objSDParameter = aParameters(iCounter)

		If objSDParameter.Direction <> icOUTONLY Then
			vParamValue = objSOAPPackager.GetParameter(icREQUEST, objSDParameter.Name)
			If err.number <> 0 Then
				LogError err.description, err.number
				ON ERROR GOTO 0 
			End If
			strParamList = strParamList & (FormatDataType(objSDMethod, objSDParameter, vParamValue, iIndex) & ",")
			If objSDParameter.Direction <> icINONLY Then
				'increase the index only if it's not an in only
				iIndex = iIndex + 1
			End If
		End if
	Next
	 
	'Exit if there  aren't any parameters
	If strParamList = "" Then 
		ConstructParameterList = ""
		Exit Function
	End If
	 
	'Trim off final comma
	strParamList = mid(strParamList,1, Len(strParamList) - 1)
	ConstructParameterList = strParamList
	 
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0 
	End If

End Function

'____________________________________________________________________________________________________________________________________________________________

Function FormatDataType(Byval oMethod, ByVal oParam, ByVal vParamValue, ByVal Index)
	'This will validate the paramater data type against the currently
	'loaded service according to the sdl and return the formatted data accordingly
	Dim lDataType
	Dim strFormattedDataType
	Dim tmpParamPassed
	
	lDataType = oParam.Type

	
	ON ERROR RESUME NEXT

	Select Case lDataType
		Case icVT_BOOL
			strFormattedDataType = "CBool(" & vParamValue & ")"
		Case icVT_BSTR
			vParamValue = Replace(vParamValue, Chr(34), (Chr(34) & Chr(34))) 
			strFormattedDataType = "Cstr(" & chr(34) & vParamValue & chr(34) & ")"
		Case icVT_DECIMAL, icVT_R4
			strFormattedDataType = "CSng(" & vParamValue & ")"
		Case icVT_EMPTY
			strFormattedDataType = "NULL"
		Case icVT_I1, icVT_UI1
			strFormattedDataType = "CByte(" & vParamValue & ")"
		Case icVT_I2, icVT_UI2
			strFormattedDataType = "CInt(" & vParamValue & ")"
		Case icVT_I4, icVT_UI4
			strFormattedDataType = "CLng(" & vParamValue & ")"
		Case icVT_R8
			strFormattedDataType = "CDbl(" & vParamValue & ")"
		Case icVT_UNKNOWN
			'Return as a string
			vParamValue = Replace(vParamValue, Chr(34), (Chr(34) & Chr(34))) 
			strFormattedDataType = "Cstr(" & chr(34) & vParamValue & chr(34) & ")"
		Case Else
			LogError "Cannot determine data type IN Function FormatDataType with " &  strMethodName & ", " & strParamName & ", " & vParamValue
	End Select

	If oParam.Direction = icBOTH Then
		'ByREF
		'Assign the value to the array of call parameters
		tmpParamPassed = "aCallParams(" & Index & ")"
		Execute tmpParamPassed & " = " & strFormattedDataType
		FormatDataType = tmpParamPassed
	Else
		FormatDataType = strFormattedDataType
	End If
	
	
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0	
	End If
	
End Function

'____________________________________________________________________________________________________________________________________________________________


Sub StuffEnvelope(ByVal vReturnData)
	ON ERROR RESUME NEXT
	
	Dim strTempElement
	Dim strReturnElementName
	Dim iCounter
	Dim iIndexPos
	
	vReturnData = Replace(vReturnData, (chr(34) & chr(34)), chr(34))

	'Initialize the counter. This counter will track the number
	'of the curent parameter which could be offset by one if this
	'is a function
	iIndexPos = 0
	strResponseStruct = objSOAPPackager.GetMethodStruct(strServiceName, icOUTPUT)
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0
	End If

	objSOAPPackager.SetPayloadData icRESPONSE, "", cstr(strServiceName),  cstr(strResponseStruct)

	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0
	End If

	Set objSDParameter = aOutParams(0)
	strReturnElementName = objSDParameter.Name
	'If this is a function, the first response param will be the output			
	If blnIsFunction Then
		objSOAPPackager.SetParameter icRESPONSE, strReturnElementName, Cstr(vReturnData)
		'The iIndexPos should still = 0
		'iIndexPos = 0
		If err.number <> 0 Then
			LogError err.description, err.number
			ON ERROR GOTO 0
		End If
	Else
		objSOAPPackager.SetParameter icRESPONSE, strReturnElementName, Cstr(aCallParams(0))
		'The iIndexPos should go to the next in the array for any potential byRefs
		iIndexPos = 1
	End If

	'Loop through aCallParams() and add them to the return package 
	'IFF they are ByRefs
	For iCounter = 1 to (UBound(aOutParams) - 1)
		'If there are any additional ByRefs to add, add them
		Set objSDParameter = aOutParams(iCounter)
		strReturnElementName = objSDParameter.Name
		If Len(trim(strReturnElementName)) Then
			objSOAPPackager.SetParameter icRESPONSE, strReturnElementName, Cstr(aCallParams(iIndexPos))
		Else
			Exit For
		End If
		iIndexPos = iIndexPos + 1
	Next 'iCounter
			
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0
	End If

	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0
	End If

End Sub

'____________________________________________________________________________________________________________________________________________________________

'***********************************************************************
'							MAIN CODE
'***********************************************************************

	ON ERROR RESUME NEXT
	
	Set objSOAPPackager		= Server.CreateObject("ROPE.SOAPPackager")
	Set objSDMethod			= server.CreateObject("ROPE.SDMethodInfo")
	Set objSDParameter		= server.CreateObject("ROPE.SDParameterInfo")
	Set xmlDOM				= Server.CreateObject("Microsoft.XMLDOM")

	If err.number <> 0 Then
		LogError err.description, err.number
	End If

	'Establish the ContentType for the output
	Response.ContentType = "text/xml"
	Response.AddHeader "MessageType", "CallResponse"

	'Get the XML from the post
	Set xmlPost = Request

	'Load posted XML into XML DOM
	xmlDOM.load (xmlPost) 
	Set xmlPost = NOTHING
	strXMLRequest = xmlDOM.xml
	
	'Load the Method Invocation HTTP Headers
	'strMethodInvocHeader = Request.ServerVariables("HTTP_SOAPMETHODNAME")

	'Get the sdl location
	strSDLLocation = SOAP_SDLURI
	
	'If nothing was posted, we return a SOAP invalid request
	If Len(trim(strXMLRequest)) = 0 Then
		LogError "Nothing was posted", SERR_INVALIDREQUEST
	End If
	
	'Load the SDL
	If USEPHYSICAL_SDLLOC Then
		objSOAPPackager.LoadServicesDescription icSTRING, GetSDLAsText(), ""
	Else
		objSOAPPackager.LoadServicesDescription icURI, strSDLLocation, ""
	End If
	If err.number <> 0 Then
		LogError err.description, err.number
	End If

	'set request payload
	objSOAPPackager.SetPayload icREQUEST, strXMLRequest

	If err.number <> 0 Then
		LogError "Failed to set payload - " & err.description, err.number
	End If

	'Populate the strServiceName() array and
	'retrieve the number of services into iNumServices
	
	Call GetService()

	'Create a collection of the methods
	Set objROPECollection = objSOAPPackager.GetServiceDescriptors(icMETHODINFO)
	'Set objROPECollection = objSOAPPackager.GetSDData(icMETHODINFO)

	If err.number <> 0 Then
		LogError err.description, err.number
	End If
	
	'Create instance of the appropriate method
	Set objSDMethod = objROPECollection(trim(cstr(strServiceName)))
	
	'Is this a function?
	blnIsFunction = objSDMethod.Type <> icMETHOD
	strParameterString = ConstructParameterList()

	If blnIsFunction Then
		'insert parens if this is a function
		strParameterString = "(" & strParameterString & ")"
	Else
		'Insert a space to provide for space before the method call
		strParameterString = " " & strParameterString
	End If

	BuildOutputParamArray

	strEval = strServiceName & strParameterString
	
	If blnIsFunction Then
		Call StuffEnvelope(Eval(strEval))
	Else
		Execute strEval
		'Need to determine if there are any OUT parameters at all, whether
		'they area OUT only OR BOTH
		If blnIsOutput Then	StuffEnvelope ""
	End If	
	If err.number <> 0 Then
		LogError err.description, err.number
		ON ERROR GOTO 0
	End If	

	If blnIsOutput Then
		'Output the results if not a one-way
		strXMLResponse = objSOAPPackager.GetPayload(icRESPONSE) 
		If err.number <> 0 Then
			LogError err.description, err.number
			ON ERROR GOTO 0
		End If
		Response.Write strXMLResponse
	End If
	
	Set xmlDOM			= NOTHING
	Set objSOAPPackager = NOTHING
	Set objSDMethod		= NOTHING
	Set objSDParameter	= NOTHING

%>