
import com.rational.test.tss.*;
import com.rational.test.tss.TSSConstants;
import java.awt.*;
import java.awt.event.*;


import java.util.Calendar;

/*
This test script demonstrates how to call all TSS Methods associated with logging.
*/

public class BatchFile extends com.rational.test.tss.TestScript {

	public class TimedFrame extends java.awt.Frame {

			int delay = 8000;

			public TimedFrame() {
				initComponents ();
				pack ();
			}

			private void initComponents() {
				label1 = new java.awt.Label("Running Batch Update");
				setLayout(new java.awt.FlowLayout());
				setBackground(java.awt.Color.lightGray);
				label1.setFont(new java.awt.Font ("Dialog", Font.BOLD, 18));
				label1.setName(".Label1");
				label1.setBackground(java.awt.Color.lightGray);
				label1.setForeground(java.awt.Color.black);
				add(label1);
				addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) { System.exit(0); }
				});
			}
	}

	public static void main(String[] args){
				BatchFile t = new BatchFile();
				t.testMain(args);
				System.exit(0);
	}

	public void testMain(String [] args) {
	try
	{

		TimedFrame tf = new TimedFrame ();
		tf.setLocation(300,300);
		tf.show ();

		// The following is used to write a message to the test log
			TSSLog.message("Starting Batch File",TSS_LOG_RESULT_INFO,null);

		// The following is used for debugging purposes; it is not necessary. The text
		// is written to the Virtual Tester Output File, accessed by right-clicking on
		// a Computer Start entry in the Test Log
		System.out.println("TSSLog.message for BatchFile was called.");


		// Defining the vriable for BatchFileCheck
		TSSNamedValue[] BatchFileCheck = new TSSNamedValue[1];
		BatchFileCheck[0] = new TSSNamedValue();
		BatchFileCheck[0].name = "Did Batch Process Complete?";
		BatchFileCheck[0].value = "Yes";


		// The following is used to write testcase results to the test log
		TSSLog.event("Did Batch Process Complete?", TSS_LOG_RESULT_PASS, "Batch Process Completed Successfully", BatchFileCheck);

		// The following is used for debugging purposes; it is not necessary. The text
		// is written to the Virtual Tester Output File, accessed by right-clicking on
		// a Computer Start entry in the Test Log
			System.out.println("TSSLog.event for BatchFile was called.");

		// The following incorporates a delay in order to keep the "..." dialog
		// (established in initComponenets) up on the screen for some number of seconds.

		Calendar stopTime = Calendar.getInstance();
		stopTime.add(Calendar.MILLISECOND,tf.delay);
		Calendar curTime = Calendar.getInstance();
		while (curTime.before(stopTime)) { curTime = Calendar.getInstance(); }

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}
	}

	private java.awt.Label label1;
}