package com.rational.cdshop.ejb;

import java.util.Properties;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.NoSuchEntityException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * This is an Entity Bean class with CMP fields
 */
public class CdBean implements EntityBean {
	public String cd_dbid;
	public String composer;
	public String composition;
	public String conductor;
	public String description;
	private EntityContext entityContext = null;
	public String image;
	public String performer;
	public double price;
	final static long serialVersionUID = 3206093459760846163L;
	public int tax_code;
	public String upc;
	private transient boolean       isDirty;   // flag to determine whether or not the
                                             // bean needs to be written to storage.


/**
 * ejbActivate method comment
 * @exception javax.ejb.EJBException The exception description.
 */
public void ejbActivate() {
}
/**
 * ejbCreate method for a CMP entity bean
 * @param argCd_dbid int
 * @exception javax.ejb.CreateException The exception description.
 * @exception javax.ejb.EJBException The exception description.
 */
public java.lang.String ejbCreate(String argCd_dbid) throws javax.ejb.CreateException, java.rmi.RemoteException {
	// All CMP fields should be initialized here.
	cd_dbid = argCd_dbid;
	return null;
}
/**
 * ejbLoad method comment
 * @exception javax.ejb.EJBException The exception description.
 */
public void ejbLoad() {
}
/**
 * ejbPassivate method comment
 * @exception javax.ejb.EJBException The exception description.
 */
public void ejbPassivate() {}
/**
 * ejbPostCreate method for a CMP entity bean
 * @param argCd_dbid int
 * @exception javax.ejb.EJBException The exception description.
 */
public void ejbPostCreate(String argCd_dbid) {}
/**
 * ejbRemove method comment
 * @exception javax.ejb.EJBException The exception description.
 * @exception javax.ejb.RemoveException The exception description.
 */
public void ejbRemove() throws javax.ejb.RemoveException {
}
/**
 * ejbStore method comment
 * @exception javax.ejb.EJBException The exception description.
 */
public void ejbStore() {}
/**
 * Getter method for composer
 * @return java.lang.String
 */
public java.lang.String getComposer() throws java.rmi.RemoteException {
	return composer;
}
/**
 * Getter method for composition
 * @return java.lang.String
 */
public java.lang.String getComposition() throws java.rmi.RemoteException {
	return composition;
}
/**
 * Getter method for conductor
 * @return java.lang.String
 */
public java.lang.String getConductor() throws java.rmi.RemoteException {
	return conductor;
}
/**
 * Getter method for description
 * @return java.lang.String
 */
public java.lang.String getDescription() throws java.rmi.RemoteException {
	return description;
}
/**
 * getEntityContext method comment
 * @return javax.ejb.EntityContext
 */
public javax.ejb.EntityContext getEntityContext() {
	return entityContext;
}
/**
 * Getter method for image
 * @return java.lang.String
 */
public java.lang.String getImage() throws java.rmi.RemoteException {
	return image;
}
/**
 * Getter method for performer
 * @return java.lang.String
 */
public java.lang.String getPerformer() throws java.rmi.RemoteException {
	return performer;
}
/**
 * Getter method for price
 * @return double
 */
public double getPrice() throws java.rmi.RemoteException {
	return price;
}
/**
 * Getter method for tax_code
 * @return int
 */
public int getTax_code() throws java.rmi.RemoteException {
	return tax_code;
}
/**
 * Getter method for upc
 * @return java.lang.String
 */
public java.lang.String getUpc() throws java.rmi.RemoteException {
	return upc;
}
/**
 * Setter method for composer
 * @param newValue java.lang.String
 */
public void setComposer(java.lang.String newValue) throws java.rmi.RemoteException {
	this.composer = newValue;
}
/**
 * Setter method for composition
 * @param newValue java.lang.String
 */
public void setComposition(java.lang.String newValue) throws java.rmi.RemoteException {
	this.composition = newValue;
}
/**
 * Setter method for conductor
 * @param newValue java.lang.String
 */
public void setConductor(java.lang.String newValue) throws java.rmi.RemoteException {
	this.conductor = newValue;
}
/**
 * Setter method for description
 * @param newValue java.lang.String
 */
public void setDescription(java.lang.String newValue) throws java.rmi.RemoteException {
	this.description = newValue;
}
/**
 * setEntityContext method comment
 * @param ctx javax.ejb.EntityContext
 * @exception javax.ejb.EJBException The exception description.
 */
public void setEntityContext(javax.ejb.EntityContext ctx) {
	entityContext = ctx;
}
/**
 * Setter method for image
 * @param newValue java.lang.String
 */
public void setImage(java.lang.String newValue) throws java.rmi.RemoteException {
	this.image = newValue;
}
/**
 * Setter method for performer
 * @param newValue java.lang.String
 */
public void setPerformer(java.lang.String newValue) throws java.rmi.RemoteException {
	this.performer = newValue;
}
/**
 * Setter method for price
 * @param newValue double
 */
public void setPrice(double newValue) throws java.rmi.RemoteException {
	this.price = newValue;
}
/**
 * Setter method for tax_code
 * @param newValue int
 */
public void setTax_code(int newValue) throws java.rmi.RemoteException {
	this.tax_code = newValue;
}
/**
 * Setter method for upc
 * @param newValue java.lang.String
 */
public void setUpc(java.lang.String newValue) throws java.rmi.RemoteException {
	this.upc = newValue;
}
/**
 * unsetEntityContext method comment
 * @exception javax.ejb.EJBException The exception description.
 */
public void unsetEntityContext() {
	entityContext = null;
}

/**
 * Insert the method's description here.
 * Creation date: (05/04/01 13:32:25)
 */
public CdBean() {}


  /** 
   * Returns whether the EJBean has been modified or not.
   *
   * This method must be public for the container to be able to invoke it.
   * 
   * @return                  boolean isDirty
   */
  public boolean isModified() {
    return isDirty;
  }

  /**
   * Sets the EJBean's modified flag.
   * 
   * @param flag              Modified Flag
   */
  public void setModified(boolean flag) {
    isDirty = flag;
  }

}